]> git.ipfire.org Git - thirdparty/git.git/blame - git-stash.sh
stash: complain about unknown flags
[thirdparty/git.git] / git-stash.sh
CommitLineData
f2c66ed1
NS
1#!/bin/sh
2# Copyright (c) 2007, Nanako Shiraishi
3
a5ab00c5
SB
4dashless=$(basename "$0" | sed -e 's/-/ /')
5USAGE="list [<options>]
fcdd0e92
SB
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
a5ab00c5 9 or: $dashless branch <branchname> [<stash>]
78751302
DC
10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]]
a5ab00c5 12 or: $dashless clear"
f2c66ed1 13
3cd2491a 14SUBDIRECTORY_OK=Yes
8f321a39 15OPTIONS_SPEC=
d0ea45bf 16START_DIR=$(pwd)
f2c66ed1 17. git-sh-setup
8a583bec 18. git-sh-i18n
f2c66ed1 19require_work_tree
ceff079b 20cd_to_toplevel
f2c66ed1
NS
21
22TMP="$GIT_DIR/.git-stash.$$"
3ba2e865
JS
23TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
24trap 'rm -f "$TMP-"* "$TMPindex"' 0
f2c66ed1
NS
25
26ref_stash=refs/stash
27
dda1f2a5
TR
28if git config --get-colorbool color.interactive; then
29 help_color="$(git config --get-color color.interactive.help 'red bold')"
30 reset_color="$(git config --get-color '' reset)"
31else
32 help_color=
33 reset_color=
34fi
35
f2c66ed1 36no_changes () {
6848d58c 37 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
78751302
DC
38 git diff-files --quiet --ignore-submodules &&
39 (test -z "$untracked" || test -z "$(untracked_files)")
40}
41
42untracked_files () {
43 excl_opt=--exclude-standard
44 test "$untracked" = "all" && excl_opt=
45 git ls-files -o -z $excl_opt
f2c66ed1
NS
46}
47
48clear_stash () {
3023dc69
JH
49 if test $# != 0
50 then
b1440ce2 51 die "$(gettext "git stash clear with parameters is unimplemented")"
3023dc69 52 fi
1956dfa8 53 if current=$(git rev-parse --verify --quiet $ref_stash)
7ab3cc70 54 then
a9ee9bf9 55 git update-ref -d $ref_stash $current
7ab3cc70 56 fi
f2c66ed1
NS
57}
58
bc9e7399 59create_stash () {
9f62e18a 60 stash_msg="$1"
78751302 61 untracked="$2"
9f62e18a 62
1eff26c0 63 git update-index -q --refresh
f2c66ed1
NS
64 if no_changes
65 then
f2c66ed1
NS
66 exit 0
67 fi
f12e925a 68
f2c66ed1 69 # state of the base commit
5be60078 70 if b_commit=$(git rev-parse --verify HEAD)
f2c66ed1 71 then
b0e621ad 72 head=$(git rev-list --oneline -n 1 HEAD --)
f2c66ed1 73 else
b1440ce2 74 die "$(gettext "You do not have the initial commit yet")"
f2c66ed1
NS
75 fi
76
5be60078 77 if branch=$(git symbolic-ref -q HEAD)
f2c66ed1
NS
78 then
79 branch=${branch#refs/heads/}
80 else
81 branch='(no branch)'
82 fi
83 msg=$(printf '%s: %s' "$branch" "$head")
84
85 # state of the index
5be60078 86 i_tree=$(git write-tree) &&
6143fa2c 87 i_commit=$(printf 'index on %s\n' "$msg" |
5be60078 88 git commit-tree $i_tree -p $b_commit) ||
b1440ce2 89 die "$(gettext "Cannot save the current index state")"
f2c66ed1 90
78751302
DC
91 if test -n "$untracked"
92 then
93 # Untracked files are stored by themselves in a parentless commit, for
94 # ease of unpacking later.
95 u_commit=$(
96 untracked_files | (
bed137d2
EP
97 GIT_INDEX_FILE="$TMPindex" &&
98 export GIT_INDEX_FILE &&
78751302
DC
99 rm -f "$TMPindex" &&
100 git update-index -z --add --remove --stdin &&
101 u_tree=$(git write-tree) &&
102 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
103 rm -f "$TMPindex"
104 ) ) || die "Cannot save the untracked files"
105
106 untracked_commit_option="-p $u_commit";
107 else
108 untracked_commit_option=
109 fi
110
dda1f2a5
TR
111 if test -z "$patch_mode"
112 then
113
114 # state of the working tree
115 w_tree=$( (
3ba2e865
JS
116 git read-tree --index-output="$TMPindex" -m $i_tree &&
117 GIT_INDEX_FILE="$TMPindex" &&
dda1f2a5 118 export GIT_INDEX_FILE &&
44df2e29
JM
119 git diff --name-only -z HEAD -- >"$TMP-stagenames" &&
120 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
dda1f2a5 121 git write-tree &&
3ba2e865 122 rm -f "$TMPindex"
dda1f2a5 123 ) ) ||
b1440ce2 124 die "$(gettext "Cannot save the current worktree state")"
dda1f2a5
TR
125
126 else
127
b24f56d6 128 rm -f "$TMP-index" &&
dda1f2a5
TR
129 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
130
131 # find out what the user wants
132 GIT_INDEX_FILE="$TMP-index" \
133 git add--interactive --patch=stash -- &&
134
135 # state of the working tree
136 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
b1440ce2 137 die "$(gettext "Cannot save the current worktree state")"
f2c66ed1 138
44df2e29 139 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
dda1f2a5 140 test -s "$TMP-patch" ||
b1440ce2 141 die "$(gettext "No changes selected")"
dda1f2a5
TR
142
143 rm -f "$TMP-index" ||
b1440ce2 144 die "$(gettext "Cannot remove temporary index (can't happen)")"
dda1f2a5
TR
145
146 fi
147
f2c66ed1 148 # create the stash
9f62e18a
JH
149 if test -z "$stash_msg"
150 then
151 stash_msg=$(printf 'WIP on %s' "$msg")
152 else
153 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
154 fi
155 w_commit=$(printf '%s\n' "$stash_msg" |
22f41286
JH
156 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
157 die "$(gettext "Cannot record working tree state")"
bc9e7399 158}
f2c66ed1 159
bd514cad
RR
160store_stash () {
161 while test $# != 0
162 do
163 case "$1" in
164 -m|--message)
165 shift
166 stash_msg="$1"
167 ;;
168 -q|--quiet)
169 quiet=t
170 ;;
171 *)
172 break
173 ;;
174 esac
175 shift
176 done
177 test $# = 1 ||
178 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
179
180 w_commit="$1"
181 if test -z "$stash_msg"
182 then
183 stash_msg="Created via \"git stash store\"."
184 fi
185
186 # Make sure the reflog for stash is kept.
187 : >>"$GIT_DIR/logs/$ref_stash"
188 git update-ref -m "$stash_msg" $ref_stash $w_commit
189 ret=$?
190 test $ret != 0 && test -z $quiet &&
191 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
192 return $ret
193}
194
bc9e7399 195save_stash () {
7bedebca 196 keep_index=
dda1f2a5 197 patch_mode=
78751302 198 untracked=
fcdd0e92
SB
199 while test $# != 0
200 do
201 case "$1" in
ea41cfc4 202 -k|--keep-index)
fcdd0e92
SB
203 keep_index=t
204 ;;
dda1f2a5 205 --no-keep-index)
3a243f70 206 keep_index=n
dda1f2a5
TR
207 ;;
208 -p|--patch)
209 patch_mode=t
3a243f70
DM
210 # only default to keep if we don't already have an override
211 test -z "$keep_index" && keep_index=t
fcdd0e92
SB
212 ;;
213 -q|--quiet)
214 GIT_QUIET=t
215 ;;
78751302
DC
216 -u|--include-untracked)
217 untracked=untracked
218 ;;
219 -a|--all)
220 untracked=all
221 ;;
3c2eb80f
MM
222 --)
223 shift
224 break
225 ;;
226 -*)
eed10649
ÆAB
227 option="$1"
228 # TRANSLATORS: $option is an invalid option, like
229 # `--blah-blah'. The 7 spaces at the beginning of the
230 # second line correspond to "error: ". So you should line
231 # up the second line with however many characters the
232 # translation of "error: " takes in your language. E.g. in
233 # English this is:
234 #
235 # $ git stash save --blah-blah 2>&1 | head -n 2
236 # error: unknown option for 'stash save': --blah-blah
237 # To provide a message, use git stash save -- '--blah-blah'
ed3c400c
RL
238 eval_gettextln "error: unknown option for 'stash save': \$option
239 To provide a message, use git stash save -- '\$option'"
3c2eb80f
MM
240 usage
241 ;;
fcdd0e92
SB
242 *)
243 break
244 ;;
245 esac
7bedebca 246 shift
fcdd0e92 247 done
7bedebca 248
78751302
DC
249 if test -n "$patch_mode" && test -n "$untracked"
250 then
d88acc91 251 die "Can't use --patch and --include-untracked or --all at the same time"
78751302
DC
252 fi
253
47629dcf 254 stash_msg="$*"
bc9e7399 255
1eff26c0 256 git update-index -q --refresh
bc9e7399
JH
257 if no_changes
258 then
5a175871 259 say "$(gettext "No local changes to save")"
bc9e7399
JH
260 exit 0
261 fi
262 test -f "$GIT_DIR/logs/$ref_stash" ||
b1440ce2 263 clear_stash || die "$(gettext "Cannot initialize stash")"
bc9e7399 264
78751302 265 create_stash "$stash_msg" $untracked
bd514cad
RR
266 store_stash -m "$stash_msg" -q $w_commit ||
267 die "$(gettext "Cannot save the current status")"
fcdd0e92 268 say Saved working directory and index state "$stash_msg"
7bedebca 269
dda1f2a5 270 if test -z "$patch_mode"
7bedebca 271 then
dda1f2a5 272 git reset --hard ${GIT_QUIET:+-q}
78751302
DC
273 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
274 if test -n "$untracked"
275 then
7474b8b4 276 git clean --force --quiet -d $CLEAN_X_OPTION
78751302 277 fi
dda1f2a5 278
3a243f70 279 if test "$keep_index" = "t" && test -n $i_tree
dda1f2a5
TR
280 then
281 git read-tree --reset -u $i_tree
282 fi
283 else
284 git apply -R < "$TMP-patch" ||
b1440ce2 285 die "$(gettext "Cannot remove worktree changes")"
dda1f2a5 286
3a243f70 287 if test "$keep_index" != "t"
dda1f2a5
TR
288 then
289 git reset
290 fi
7bedebca 291 fi
f2c66ed1
NS
292}
293
401de405 294have_stash () {
1956dfa8 295 git rev-parse --verify --quiet $ref_stash >/dev/null
401de405
JK
296}
297
f2c66ed1 298list_stash () {
401de405 299 have_stash || return 0
288c67ca 300 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
f2c66ed1
NS
301}
302
303show_stash () {
d6cc2df5 304 ALLOW_UNKNOWN_FLAGS=t
a9bf09e1 305 assert_stash_like "$@"
14cd4581 306
a9bf09e1 307 git diff ${FLAGS:---stat} $b_commit $w_commit
f2c66ed1
NS
308}
309
ef763129
JS
310#
311# Parses the remaining options looking for flags and
312# at most one revision defaulting to ${ref_stash}@{0}
313# if none found.
314#
315# Derives related tree and commit objects from the
316# revision, if one is found.
317#
318# stash records the work tree, and is a merge between the
319# base commit (first parent) and the index tree (second parent).
320#
321# REV is set to the symbolic version of the specified stash-like commit
322# IS_STASH_LIKE is non-blank if ${REV} looks like a stash
323# IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
324# s is set to the SHA1 of the stash commit
325# w_commit is set to the commit containing the working tree
326# b_commit is set to the base commit
327# i_commit is set to the commit containing the index tree
78751302 328# u_commit is set to the commit containing the untracked files tree
ef763129
JS
329# w_tree is set to the working tree
330# b_tree is set to the base tree
331# i_tree is set to the index tree
78751302 332# u_tree is set to the untracked files tree
ef763129
JS
333#
334# GIT_QUIET is set to t if -q is specified
335# INDEX_OPTION is set to --index if --index is specified.
d6cc2df5 336# FLAGS is set to the remaining flags (if allowed)
ef763129
JS
337#
338# dies if:
339# * too many revisions specified
340# * no revision is specified and there is no stash stack
341# * a revision is specified which cannot be resolve to a SHA1
342# * a non-existent stash reference is specified
d6cc2df5 343# * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
ef763129
JS
344#
345
346parse_flags_and_rev()
347{
348 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
349 PARSE_CACHE="$*"
350
351 IS_STASH_LIKE=
352 IS_STASH_REF=
353 INDEX_OPTION=
354 s=
355 w_commit=
356 b_commit=
357 i_commit=
78751302 358 u_commit=
ef763129
JS
359 w_tree=
360 b_tree=
361 i_tree=
78751302 362 u_tree=
ef763129 363
2a07e437 364 REV=$(git rev-parse --no-flags --symbolic --sq "$@") || exit 1
ef763129
JS
365
366 FLAGS=
2bea593b 367 for opt
ef763129 368 do
2bea593b
JS
369 case "$opt" in
370 -q|--quiet)
371 GIT_QUIET=-t
372 ;;
ef763129
JS
373 --index)
374 INDEX_OPTION=--index
375 ;;
2bea593b 376 -*)
d6cc2df5
JK
377 test "$ALLOW_UNKNOWN_FLAGS" = t ||
378 die "$(eval_gettext "unknown option: \$opt")"
2bea593b 379 FLAGS="${FLAGS}${FLAGS:+ }$opt"
ef763129
JS
380 ;;
381 esac
ef763129
JS
382 done
383
2a07e437 384 eval set -- $REV
ef763129
JS
385
386 case $# in
387 0)
b1440ce2 388 have_stash || die "$(gettext "No stash found.")"
ef763129
JS
389 set -- ${ref_stash}@{0}
390 ;;
391 1)
392 :
393 ;;
394 *)
33ceddcf 395 die "$(eval_gettext "Too many revisions specified: \$REV")"
ef763129
JS
396 ;;
397 esac
398
1956dfa8 399 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
155da748 400 reference="$1"
ad5fe377 401 die "$(eval_gettext "\$reference is not a valid reference")"
155da748 402 }
ef763129 403
1956dfa8 404 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
2a07e437 405 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
ef763129
JS
406 s=$1 &&
407 w_commit=$1 &&
408 b_commit=$2 &&
409 w_tree=$3 &&
410 b_tree=$4 &&
411 i_tree=$5 &&
412 IS_STASH_LIKE=t &&
413 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
414 IS_STASH_REF=t
78751302 415
1956dfa8 416 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
2a07e437 417 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
ef763129
JS
418}
419
420is_stash_like()
421{
422 parse_flags_and_rev "$@"
423 test -n "$IS_STASH_LIKE"
424}
425
426assert_stash_like() {
777b6f13
ÆAB
427 is_stash_like "$@" || {
428 args="$*"
429 die "$(eval_gettext "'\$args' is not a stash-like commit")"
430 }
ef763129
JS
431}
432
433is_stash_ref() {
434 is_stash_like "$@" && test -n "$IS_STASH_REF"
435}
436
437assert_stash_ref() {
777b6f13
ÆAB
438 is_stash_ref "$@" || {
439 args="$*"
440 die "$(eval_gettext "'\$args' is not a stash reference")"
441 }
ef763129
JS
442}
443
f2c66ed1 444apply_stash () {
fcdd0e92 445
064ed100 446 assert_stash_like "$@"
f2c66ed1 447
b1440ce2 448 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
5fd448f1
OA
449
450 # current index state
451 c_tree=$(git write-tree) ||
b1440ce2 452 die "$(gettext "Cannot apply a stash in the middle of a merge")"
5fd448f1 453
cbeaccc3 454 unstashed_index_tree=
064ed100 455 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
7bedebca 456 test "$c_tree" != "$i_tree"
cbeaccc3 457 then
89d750bf 458 git diff-tree --binary $s^2^..$s^2 | git apply --cached
150937c4 459 test $? -ne 0 &&
b1440ce2 460 die "$(gettext "Conflicts in index. Try without --index.")"
52070790 461 unstashed_index_tree=$(git write-tree) ||
b1440ce2 462 die "$(gettext "Could not save index tree")"
150937c4 463 git reset
cbeaccc3 464 fi
150937c4 465
78751302
DC
466 if test -n "$u_tree"
467 then
468 GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
469 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
470 rm -f "$TMPindex" ||
471 die 'Could not restore untracked files from stash'
472 fi
473
f2c66ed1
NS
474 eval "
475 GITHEAD_$w_tree='Stashed changes' &&
476 GITHEAD_$c_tree='Updated upstream' &&
477 GITHEAD_$b_tree='Version stash was based on' &&
478 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
479 "
480
fcdd0e92
SB
481 if test -n "$GIT_QUIET"
482 then
69ae92bd 483 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
fcdd0e92 484 fi
52070790 485 if git merge-recursive $b_tree -- $c_tree $w_tree
f2c66ed1
NS
486 then
487 # No conflict
cbeaccc3
JH
488 if test -n "$unstashed_index_tree"
489 then
490 git read-tree "$unstashed_index_tree"
83b3df7d
JH
491 else
492 a="$TMP-added" &&
89d750bf 493 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
83b3df7d
JH
494 git read-tree --reset $c_tree &&
495 git update-index --add --stdin <"$a" ||
b1440ce2 496 die "$(gettext "Cannot unstage modified files")"
83b3df7d 497 rm -f "$a"
cbeaccc3 498 fi
fcdd0e92
SB
499 squelch=
500 if test -n "$GIT_QUIET"
501 then
502 squelch='>/dev/null 2>&1'
503 fi
26b59b48 504 (cd "$START_DIR" && eval "git status $squelch") || :
f2c66ed1
NS
505 else
506 # Merge conflict; keep the exit status from merge-recursive
150937c4 507 status=$?
743bf6d8 508 git rerere
064ed100 509 if test -n "$INDEX_OPTION"
cbeaccc3 510 then
6fdd50e9 511 gettextln "Index was not unstashed." >&2
cbeaccc3 512 fi
150937c4 513 exit $status
f2c66ed1
NS
514 fi
515}
516
f276872d
JS
517pop_stash() {
518 assert_stash_ref "$@"
519
2d4c9933
JH
520 if apply_stash "$@"
521 then
522 drop_stash "$@"
523 else
524 status=$?
525 say "The stash is kept in case you need it again."
526 exit $status
527 fi
f276872d
JS
528}
529
e25d5f9c 530drop_stash () {
92e39e44 531 assert_stash_ref "$@"
e25d5f9c 532
92e39e44 533 git reflog delete --updateref --rewrite "${REV}" &&
d4ca6c8b
ÆAB
534 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
535 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
e25d5f9c
BC
536
537 # clear_stash if we just dropped the last stash entry
1956dfa8
DA
538 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
539 clear_stash
e25d5f9c
BC
540}
541
656b5034 542apply_to_branch () {
b1440ce2 543 test -n "$1" || die "$(gettext "No branch name specified")"
656b5034 544 branch=$1
fb433dc9 545 shift 1
656b5034 546
fb433dc9
JS
547 set -- --index "$@"
548 assert_stash_like "$@"
549
550 git checkout -b $branch $REV^ &&
57693d03
JS
551 apply_stash "$@" && {
552 test -z "$IS_STASH_REF" || drop_stash "$@"
553 }
656b5034
AMS
554}
555
ef763129 556PARSE_CACHE='--not-parsed'
3c2eb80f
MM
557# The default command is "save" if nothing but options are given
558seen_non_option=
559for opt
560do
561 case "$opt" in
562 -*) ;;
563 *) seen_non_option=t; break ;;
564 esac
565done
566
567test -n "$seen_non_option" || set "save" "$@"
568
f2c66ed1
NS
569# Main command set
570case "$1" in
fcb10a96
JH
571list)
572 shift
f2c66ed1
NS
573 list_stash "$@"
574 ;;
575show)
576 shift
577 show_stash "$@"
578 ;;
683befa1
KL
579save)
580 shift
47629dcf 581 save_stash "$@"
683befa1 582 ;;
f2c66ed1
NS
583apply)
584 shift
585 apply_stash "$@"
586 ;;
587clear)
3023dc69
JH
588 shift
589 clear_stash "$@"
f2c66ed1 590 ;;
bc9e7399 591create)
0719f300 592 shift
bc9e7399
JH
593 create_stash "$*" && echo "$w_commit"
594 ;;
bd514cad
RR
595store)
596 shift
597 store_stash "$@"
598 ;;
e25d5f9c
BC
599drop)
600 shift
601 drop_stash "$@"
602 ;;
bd56ff54
BC
603pop)
604 shift
f276872d 605 pop_stash "$@"
bd56ff54 606 ;;
656b5034
AMS
607branch)
608 shift
609 apply_to_branch "$@"
610 ;;
f2c66ed1 611*)
3c2eb80f
MM
612 case $# in
613 0)
97bc00a4 614 save_stash &&
5a175871 615 say "$(gettext "(To restore them type \"git stash apply\")")"
ea41cfc4
JS
616 ;;
617 *)
683befa1 618 usage
ea41cfc4 619 esac
9f62e18a 620 ;;
f2c66ed1 621esac